#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK48x3x48TN3x3x1_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=48, NB=3, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=3, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   const double *stM = A + 2304;
   const double *stN = B + 144;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*3)/(48*3);
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 96, incAn = -2304;
   #define incBk 1
   const int incBm = -48, incBn = 144;
   #define incCm 3
   const int incCn = (((ldc) << 1)+ldc) - 48;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2;
   do /* M-loop */
   {
      ATL_pfl1R(pfA);
      ATL_pfl1R(pfA+ATL_L1LS);
      ATL_pfl1R(pfA+3*ATL_L1LS);
      ATL_pfl1R(pfA+4*ATL_L1LS);
      ATL_pfl1R(pfA+5*ATL_L1LS);
      ATL_pfl1R(pfA+6*ATL_L1LS);
      ATL_pfl1R(pfA+7*ATL_L1LS);
      ATL_pfl1R(pfA+8*ATL_L1LS);
      ATL_pfl1R(pfA+9*ATL_L1LS);
      ATL_pfl1R(pfA+10*ATL_L1LS);
      ATL_pfl1R(pfA+11*ATL_L1LS);
      ATL_pfl1R(pfA+12*ATL_L1LS);
      ATL_pfl1R(pfA+13*ATL_L1LS);
      ATL_pfl1R(pfA+14*ATL_L1LS);
      ATL_pfl1R(pfA+15*ATL_L1LS);
      ATL_pfl1R(pfA+16*ATL_L1LS);
      ATL_pfl1R(pfA+17*ATL_L1LS);
      pfA += incPFA;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      rC0_1 = *pC1;
      rC0_2 = *pC2;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[48];
      rA2 = pA0[96];
      rC0_0 = rA0 * rB0;
      rB1 = pB0[48];
      rC1_0 = rA1 * rB0;
      rB2 = pB0[96];
      rC2_0 = rA2 * rB0;
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC2_1 = rA2 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC2_2 = rA2 * rB2;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=47; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[48];
         rA2 = pA0[96];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[48];
         rC1_0 += rA1 * rB0;
         rB2 = pB0[96];
         rC2_0 += rA2 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      pC1[2] = rC2_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      pC2[2] = rC2_2;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pA0 += incAm;
      pB0 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK48x48x48TN48x48x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=48, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=3, nu=9, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 2304;
   const double *stN = B + 2160;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*9)/(48*48);
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 96, incAn = -2304;
   #define incBk 1
   const int incBm = -48, incBn = 432;
   #define incCm 3
   const int incCn = (((ldc) << 3)+ldc) - 48;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc), *pC8=pC7+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7, rB8;
   register double rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3, rC0_4, rC1_4, rC2_4, rC0_5, rC1_5, rC2_5, rC0_6, rC1_6, rC2_6, rC0_7, rC1_7, rC2_7, rC0_8, rC1_8, rC2_8;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         ATL_pfl1R(pfA+ATL_L1LS);
         pfA += incPFA;
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         rC0_4 = *pC4;
         rC0_5 = *pC5;
         rC0_6 = *pC6;
         rC0_7 = *pC7;
         rC0_8 = *pC8;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
         ATL_pfl1W(pC5);
         ATL_pfl1W(pC6);
         ATL_pfl1W(pC7);
         ATL_pfl1W(pC8);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[48];
         rA2 = pA0[96];
         rC0_0 = rA0 * rB0;
         rB1 = pB0[48];
         rC1_0 = rA1 * rB0;
         rB2 = pB0[96];
         rC2_0 = rA2 * rB0;
         rB3 = pB0[144];
         rC0_1 = rA0 * rB1;
         rB4 = pB0[192];
         rC1_1 = rA1 * rB1;
         rB5 = pB0[240];
         rC2_1 = rA2 * rB1;
         rB6 = pB0[288];
         rC0_2 = rA0 * rB2;
         rB7 = pB0[336];
         rC1_2 = rA1 * rB2;
         rB8 = pB0[384];
         rC2_2 = rA2 * rB2;
         rC0_3 = rA0 * rB3;
         rC1_3 = rA1 * rB3;
         rC2_3 = rA2 * rB3;
         rC0_4 = rA0 * rB4;
         rC1_4 = rA1 * rB4;
         rC2_4 = rA2 * rB4;
         rC0_5 = rA0 * rB5;
         rC1_5 = rA1 * rB5;
         rC2_5 = rA2 * rB5;
         rC0_6 = rA0 * rB6;
         rC1_6 = rA1 * rB6;
         rC2_6 = rA2 * rB6;
         rC0_7 = rA0 * rB7;
         rC1_7 = rA1 * rB7;
         rC2_7 = rA2 * rB7;
         rC0_8 = rA0 * rB8;
         rC1_8 = rA1 * rB8;
         rC2_8 = rA2 * rB8;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=47; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[48];
            rA2 = pA0[96];
            rC0_0 += rA0 * rB0;
            rB1 = pB0[48];
            rC1_0 += rA1 * rB0;
            rB2 = pB0[96];
            rC2_0 += rA2 * rB0;
            rB3 = pB0[144];
            rC0_1 += rA0 * rB1;
            rB4 = pB0[192];
            rC1_1 += rA1 * rB1;
            rB5 = pB0[240];
            rC2_1 += rA2 * rB1;
            rB6 = pB0[288];
            rC0_2 += rA0 * rB2;
            rB7 = pB0[336];
            rC1_2 += rA1 * rB2;
            rB8 = pB0[384];
            rC2_2 += rA2 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            rC0_7 += rA0 * rB7;
            rC1_7 += rA1 * rB7;
            rC2_7 += rA2 * rB7;
            rC0_8 += rA0 * rB8;
            rC1_8 += rA1 * rB8;
            rC2_8 += rA2 * rB8;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         *pC4 = rC0_4;
         pC4[1] = rC1_4;
         pC4[2] = rC2_4;
         *pC5 = rC0_5;
         pC5[1] = rC1_5;
         pC5[2] = rC2_5;
         *pC6 = rC0_6;
         pC6[1] = rC1_6;
         pC6[2] = rC2_6;
         *pC7 = rC0_7;
         pC7[1] = rC1_7;
         pC7[2] = rC2_7;
         *pC8 = rC0_8;
         pC8[1] = rC1_8;
         pC8[2] = rC2_8;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pC8 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pC8 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK48x3x48TN3x3x1_a1_b0(48, 3, 48, alpha, ca, lda, cb + 2160, ldb, beta, cc + (45*(ldc)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
